"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var child_process = require("child_process");
var path = require("path");
var util = require("util");
var Svn = /** @class */ (function () {
    function Svn() {
        this.NEED_ADD_STATUS = ["?"];
        this.NAME = "svn";
        this.execSync = util.promisify(child_process.exec);
    }
    Svn.prototype.status = function (project) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (project === undefined) {
                    return [2 /*return*/, this.execSync(this.NAME + " status")];
                }
                return [2 /*return*/, this.execSync(this.NAME + " status " + (path.extname(project).length > 0 ? path.dirname(project) : project))];
            });
        });
    };
    Svn.prototype.add = function (items) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var paths;
            return tslib_1.__generator(this, function (_a) {
                paths = items.map(function (item) { return item.slice(2); });
                return [2 /*return*/, this.execSync(this.NAME + " add " + paths.join(" "))];
            });
        });
    };
    Svn.prototype.commit = function (items, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var paths;
            return tslib_1.__generator(this, function (_a) {
                paths = items.map(function (item) { return item.slice(2); });
                return [2 /*return*/, this.execSync(this.NAME + " commit " + paths.join(" ") + " -m \"" + message + "\"")];
            });
        });
    };
    return Svn;
}());
exports.Svn = Svn;
